
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Module trialManager &#8212; pyNumericalTrials 0.1.0 documentation</title>
    <link rel="stylesheet" href="_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <script id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    <script src="_static/language_data.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Module executionManager" href="executionManager.html" />
    <link rel="prev" title="Welcome to pyNumericalTrials’s documentation!" href="index.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <div class="toctree-wrapper compound">
</div>
<div class="section" id="module-trialmanager">
<h1>Module trialManager<a class="headerlink" href="#module-trialmanager" title="Permalink to this headline">¶</a></h1>
<p>This module defines a class used to track the parameters used for a given trial of an expierment.
An example use of the class is as follows:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">pyNumericalTrials.trialManager</span> <span class="k">as</span> <span class="nn">tm</span>
<span class="kn">import</span> <span class="nn">argparse</span>

<span class="n">parser</span> <span class="o">=</span> <span class="n">argparse</span><span class="o">.</span><span class="n">ArgumentParser</span><span class="p">(</span><span class="n">description</span><span class="o">=</span><span class="s1">&#39;Test Spin Boson Evolution Code&#39;</span><span class="p">)</span>
<span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s1">&#39;--nBosons&#39;</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">int</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="mi">3</span> <span class="p">,</span><span class="n">help</span><span class="o">=</span><span class="s1">&#39;number of bosons&#39;</span><span class="p">)</span>
<span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s1">&#39;--alpha&#39;</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">float</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="mi">1</span> <span class="p">,</span><span class="n">help</span><span class="o">=</span><span class="s1">&#39;coupling paramter&#39;</span><span class="p">)</span>

<span class="n">experiementName</span> <span class="o">=</span> <span class="s2">&quot;01a_test&quot;</span>
<span class="n">databaseDir</span> <span class="o">=</span> <span class="s2">&quot;./&quot;</span>
<span class="n">trialInitser</span> <span class="o">=</span> <span class="n">tm</span><span class="o">.</span><span class="n">trialManager</span><span class="p">(</span><span class="n">parser</span><span class="p">,</span> <span class="n">experiementName</span><span class="p">,</span> <span class="s2">&quot;discription&quot;</span><span class="p">,</span> <span class="n">databaseDir</span><span class="p">,</span> <span class="n">addMaster</span> <span class="o">=</span> <span class="kc">True</span><span class="p">)</span>

<span class="k">def</span> <span class="nf">compute_point</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">dataLoc</span><span class="p">):</span>
     <span class="c1"># do some computation based on args</span>
     <span class="n">result</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">nBosons</span> <span class="o">+</span> <span class="n">args</span><span class="o">.</span><span class="n">alpha</span>
     <span class="c1"># save data</span>
     <span class="n">np</span><span class="o">.</span><span class="n">savetxt</span><span class="p">(</span><span class="n">dataLoc</span><span class="o">+</span><span class="s2">&quot;results.txt&quot;</span><span class="p">,</span> <span class="n">result</span><span class="p">)</span>

<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">dataLoc</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">trialInitser</span><span class="o">.</span><span class="n">parseNadd</span><span class="p">()</span>

    <span class="n">compute_point</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">dataLoc</span><span class="p">)</span>

    <span class="n">trialInitser</span><span class="o">.</span><span class="n">finalize</span><span class="p">()</span>
</pre></div>
</div>
<div class="section" id="structure-of-expeirments-database">
<h2>Structure of Expeirments Database<a class="headerlink" href="#structure-of-expeirments-database" title="Permalink to this headline">¶</a></h2>
<p>The database created and managed by trialManager can be used for multiple experiment scripts.
The database will then have the following tables:</p>
<blockquote>
<div><ul class="simple">
<li><p>One master table: every trial for every experiment is listed here.</p></li>
<li><p>Multiple &lt;&lt;experimentName&gt;&gt; tables for each experiment script using the database.</p></li>
<li><p>possibly Multiple &lt;&lt;experimentName&gt;&gt;sweeps tables for each experiment script which has a “sweepfile” argument used. See <code class="xref py py-mod docutils literal notranslate"><span class="pre">executionManager</span></code> for details on sweeping expierment script arguments.</p></li>
</ul>
</div></blockquote>
<p>Each script must have a different experimentName.
The master table has the following columns:</p>
<blockquote>
<div><ul class="simple">
<li><p>timestamp: date and time script was called</p></li>
<li><p>description: any given string</p></li>
<li><p>experimentName</p></li>
<li><p>state: either Initialized or Valid depending on if finalize was called before the experiment script exited.</p></li>
</ul>
</div></blockquote>
<dl>
<dt>The &lt;&lt;experimentName&gt;&gt; tables contain the following columns:</dt><dd><ul class="simple">
<li><p>masterID: rowID of trial in master table</p></li>
<li><p>computationTime: time it took between parseNadd and finalize being called. Set to -1 before finalize is called.</p></li>
<li><p>1 column for each argument of the experiment script, the arguments being swept will have NULL values</p></li>
</ul>
<dl class="simple">
<dt>The &lt;&lt;experiementName&gt;&gt;sweeps table has the following columns:</dt><dd><ul class="simple">
<li><p>localID: rowID in &lt;&lt;experimentName&gt;&gt; table for the trial</p></li>
<li><p>sweptArg: one the argument being swept</p></li>
<li><p>linOlog: linear or log sweeping</p></li>
<li><p>x0, xf, N: initial and finial value of sweep and number of steps in sweep</p></li>
</ul>
</dd>
</dl>
</dd>
</dl>
<p>Multiple rows will appear for a given trial if that trial had multiple arguments swept.</p>
</div>
<div class="section" id="module-pyNumericalTrials.trialManager">
<span id="module-members"></span><h2>Module members<a class="headerlink" href="#module-pyNumericalTrials.trialManager" title="Permalink to this headline">¶</a></h2>
<dl class="py class">
<dt id="pyNumericalTrials.trialManager.trialManager">
<em class="property">class </em><code class="sig-prename descclassname">pyNumericalTrials.trialManager.</code><code class="sig-name descname">trialManager</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">argParser</span></em>, <em class="sig-param"><span class="n">experimentName</span></em>, <em class="sig-param"><span class="n">scriptDescription</span></em>, <em class="sig-param"><span class="n">dbLoc</span></em>, <em class="sig-param"><span class="n">dbName</span><span class="o">=</span><span class="default_value">'experiments.db'</span></em>, <em class="sig-param"><span class="n">dependencies</span><span class="o">=</span><span class="default_value">[]</span></em>, <em class="sig-param"><span class="n">addMaster</span><span class="o">=</span><span class="default_value">True</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.trialManager.trialManager" title="Permalink to this definition">¶</a></dt>
<dd><p>This class creates an object which keeps track of the trials preformed by the experiment script it is called in.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>argParser</strong> – ArgParser parser that defines parameters for the experiment.</p></li>
<li><p><strong>experimentName</strong> – String giving name of the experiment table.</p></li>
<li><p><strong>scriptDescription</strong> – A string.</p></li>
<li><p><strong>dbLoc</strong> – Path to directory where the experiments database is located.</p></li>
<li><p><strong>dbName</strong> – Name of experiments database default: experiments.db</p></li>
<li><p><strong>addMaster</strong> – default=True if the masterTable or database does not exists, it is created when this function is called.</p></li>
<li><p><strong>dependencies</strong> – Not used right now.</p></li>
</ul>
</dd>
</dl>
<p>When this object is created, it only makes/loads the database.
When <a class="reference internal" href="#pyNumericalTrials.trialManager.trialManager.parseNadd" title="pyNumericalTrials.trialManager.trialManager.parseNadd"><code class="xref py py-func docutils literal notranslate"><span class="pre">parseNadd()</span></code></a> is called a new trial with the parsed arguments is added to the scripts experiment table.
When <a class="reference internal" href="#pyNumericalTrials.trialManager.trialManager.finalize" title="pyNumericalTrials.trialManager.trialManager.finalize"><code class="xref py py-func docutils literal notranslate"><span class="pre">finalize()</span></code></a> is called the database is updated marking the time it took to compleate the computation.</p>
<dl class="py attribute">
<dt id="pyNumericalTrials.trialManager.trialManager.experimentName">
<code class="sig-name descname">experimentName</code><a class="headerlink" href="#pyNumericalTrials.trialManager.trialManager.experimentName" title="Permalink to this definition">¶</a></dt>
<dd><p>String giving name of the experiment table.</p>
</dd></dl>

<dl class="py attribute">
<dt id="pyNumericalTrials.trialManager.trialManager.parser">
<code class="sig-name descname">parser</code><a class="headerlink" href="#pyNumericalTrials.trialManager.trialManager.parser" title="Permalink to this definition">¶</a></dt>
<dd><p>ArgParse parser which defines the parameters for the experiment.</p>
</dd></dl>

<dl class="py attribute">
<dt id="pyNumericalTrials.trialManager.trialManager.dbFullName">
<code class="sig-name descname">dbFullName</code><a class="headerlink" href="#pyNumericalTrials.trialManager.trialManager.dbFullName" title="Permalink to this definition">¶</a></dt>
<dd><p>Database file name and location.</p>
</dd></dl>

<dl class="py attribute">
<dt id="pyNumericalTrials.trialManager.trialManager.trialLoc">
<code class="sig-name descname">trialLoc</code><a class="headerlink" href="#pyNumericalTrials.trialManager.trialManager.trialLoc" title="Permalink to this definition">¶</a></dt>
<dd><p>Location trial data should be stored at.</p>
</dd></dl>

<p class="rubric">Methods</p>
<table class="longtable docutils align-default">
<colgroup>
<col style="width: 10%" />
<col style="width: 90%" />
</colgroup>
<tbody>
<tr class="row-odd"><td><p><a class="reference internal" href="#pyNumericalTrials.trialManager.trialManager.finalize" title="pyNumericalTrials.trialManager.trialManager.finalize"><code class="xref py py-obj docutils literal notranslate"><span class="pre">finalize</span></code></a>()</p></td>
<td><p>Adds execution time and marks trial as completed.</p></td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="#pyNumericalTrials.trialManager.trialManager.getDependenciesFileLocs" title="pyNumericalTrials.trialManager.trialManager.getDependenciesFileLocs"><code class="xref py py-obj docutils literal notranslate"><span class="pre">getDependenciesFileLocs</span></code></a>()</p></td>
<td><p>Untested</p></td>
</tr>
<tr class="row-odd"><td><p><a class="reference internal" href="#pyNumericalTrials.trialManager.trialManager.getDependenciesParameters" title="pyNumericalTrials.trialManager.trialManager.getDependenciesParameters"><code class="xref py py-obj docutils literal notranslate"><span class="pre">getDependenciesParameters</span></code></a>()</p></td>
<td><p>Untested</p></td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="#pyNumericalTrials.trialManager.trialManager.parseNadd" title="pyNumericalTrials.trialManager.trialManager.parseNadd"><code class="xref py py-obj docutils literal notranslate"><span class="pre">parseNadd</span></code></a>()</p></td>
<td><p>Parses the arguements in parser and adds arguments for the trial to the experiment table.</p></td>
</tr>
</tbody>
</table>
<dl class="py method">
<dt id="pyNumericalTrials.trialManager.trialManager.parseNadd">
<code class="sig-name descname">parseNadd</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.trialManager.trialManager.parseNadd" title="Permalink to this definition">¶</a></dt>
<dd><p>Parses the arguements in parser and adds arguments for the trial to the experiment table.</p>
<p>This function also starts a timer to track how long the code takes.</p>
<dl class="simple">
<dt>Returns: (dataLoc, args)</dt><dd><ul class="simple">
<li><p>dataLoc: Location created to store data produced by trial.</p></li>
<li><p>args:    args parsed by argParser.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt id="pyNumericalTrials.trialManager.trialManager.getDependenciesFileLocs">
<code class="sig-name descname">getDependenciesFileLocs</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.trialManager.trialManager.getDependenciesFileLocs" title="Permalink to this definition">¶</a></dt>
<dd><p>Untested</p>
</dd></dl>

<dl class="py method">
<dt id="pyNumericalTrials.trialManager.trialManager.getDependenciesParameters">
<code class="sig-name descname">getDependenciesParameters</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.trialManager.trialManager.getDependenciesParameters" title="Permalink to this definition">¶</a></dt>
<dd><p>Untested</p>
</dd></dl>

<dl class="py method">
<dt id="pyNumericalTrials.trialManager.trialManager.finalize">
<code class="sig-name descname">finalize</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.trialManager.trialManager.finalize" title="Permalink to this definition">¶</a></dt>
<dd><p>Adds execution time and marks trial as completed.</p>
</dd></dl>

</dd></dl>

<dl class="py function">
<dt id="pyNumericalTrials.trialManager.readTrial">
<code class="sig-prename descclassname">pyNumericalTrials.trialManager.</code><code class="sig-name descname">readTrial</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">dbLoc</span></em>, <em class="sig-param"><span class="n">dbName</span></em>, <em class="sig-param"><span class="n">masterID</span></em><span class="sig-paren">)</span><a class="headerlink" href="#pyNumericalTrials.trialManager.readTrial" title="Permalink to this definition">¶</a></dt>
<dd><dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>dbLoc</strong> – path where experiments database is</p></li>
<li><p><strong>dbName</strong> – name of experiments database</p></li>
</ul>
</dd>
</dl>
<dl class="simple">
<dt>Returns: (trialParams, dataLoc)</dt><dd><p>trialParams: dictionary of the trial parameters requested
dataLoc: location of the data for the trial requested.</p>
</dd>
</dl>
</dd></dl>

</div>
</div>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="index.html">pyNumericalTrials</a></h1>








<h3>Navigation</h3>
<ul class="current">
<li class="toctree-l1 current"><a class="current reference internal" href="#">Module trialManager</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#structure-of-expeirments-database">Structure of Expeirments Database</a></li>
<li class="toctree-l2"><a class="reference internal" href="#module-pyNumericalTrials.trialManager">Module members</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="executionManager.html">Module executionManager</a></li>
<li class="toctree-l1"><a class="reference internal" href="readNplot.html">Module readNplot</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="index.html">Documentation overview</a><ul>
      <li>Previous: <a href="index.html" title="previous chapter">Welcome to pyNumericalTrials’s documentation!</a></li>
      <li>Next: <a href="executionManager.html" title="next chapter">Module executionManager</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2021, Shane P. Kelly.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 3.2.1</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="_sources/trialManager.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>